/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TBVE                                                     */
/* Tabela : TABEVEND                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 29/10/2005  Renata Diniz Viana                                            */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TBVE' and
            type = 'TR'              and
            u.uid = o.uid            and
            u.name = USER)
   DROP TRIGGER DTULTATU_TBVE
GO

CREATE TRIGGER DTULTATU_TBVE ON TABEVEND
FOR INSERT, UPDATE, DELETE
AS 
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TABEVEND', CDFILIAL, 'CDFILIAL='+CDFILIAL+';'+'CDTABEPREC='+CDTABEPREC+';'+
                'DTINIVGPREC='+CONVERT(CHAR,DTINIVGPREC,120)+';',
                CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TABEVEND
      SET DTULTATUTBVE = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(TABEVEND.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0))     AND
            (ISNULL(TABEVEND.CDTABEPREC,0)   = ISNULL(INSERTED.CDTABEPREC,0))   AND
            (ISNULL(TABEVEND.DTINIVGPREC,CONVERT(DATETIME,'31/12/1899')) =
               ISNULL(INSERTED.DTINIVGPREC,CONVERT(DATETIME,'31/12/1899')));

            UPDATE ITEMPRECO
            SET DTULTATUITPR = GETDATE()
            FROM INSERTED
            WHERE ITEMPRECO.CDFILIAL    = INSERTED.CDFILIAL
              AND ITEMPRECO.CDTABEPREC  = INSERTED.CDTABEPREC
              AND ITEMPRECO.DTINIVGPREC = INSERTED.DTINIVGPREC;

   END;
END;
GO


UPDATE TABEVEND SET DTULTATUTBVE = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUTBVE IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUTBVE' and
            type = 'D')
   ALTER TABLE TABEVEND DROP CONSTRAINT DEFAULT_DTULTATUTBVE
GO

ALTER TABLE TABEVEND ADD CONSTRAINT DEFAULT_DTULTATUTBVE
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUTBVE
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TBVE','5.07.005';
GO

